/****************************************************************************************************************/
/*                                                                                                              */
/*   OpenNN: Open Neural Networks Library                                                                       */
/*   www.opennn.net                                                                                             */
/*                                                                                                              */
/*   O P E N N N   T E S T S                                                                                    */
/*                                                                                                              */
/*   Artificial Intelligence Techniques SL                                                                      */
/*   artelnics@artelnics.com                                                                                    */
/*                                                                                                              */
/****************************************************************************************************************/

#ifndef __OPENNNTESTS_H__
#define __OPENNNTESTS_H__

// OpenNN includes

// Unit testing includes

#include "vector_test.h"
#include "matrix_test.h"
#include "sparse_matrix_test.h"
#include "numerical_differentiation_test.h"

#include "instances_test.h"
#include "variables_test.h"
#include "missing_values_test.h"
#include "data_set_test.h"

#include "perceptron_layer_test.h"
#include "multilayer_perceptron_test.h"
#include "scaling_layer_test.h"
#include "unscaling_layer_test.h"
#include "bounding_layer_test.h"
#include "probabilistic_layer_test.h"
#include "inputs_test.h"
#include "outputs_test.h"
#include "neural_network_test.h"
#include "inputs_trending_layer_test.h"
#include "outputs_trending_layer_test.h"

#include "loss_index_test.h"
#include "sum_squared_error_test.h"
#include "mean_squared_error_test.h"
#include "normalized_squared_error_test.h"
#include "weighted_squared_error_test.h"
#include "minkowski_error_test.h"
#include "cross_entropy_error_test.h"

#include "learning_rate_algorithm_test.h"
#include "optimization_algorithm_test.h"
#include "gradient_descent_test.h"
#include "stochastic_gradient_descent_test.h"
#include "conjugate_gradient_test.h"
#include "quasi_newton_method_test.h"
#include "levenberg_marquardt_algorithm_test.h"
#include "stochastic_gradient_descent_test.h"
#include "training_strategy_test.h"

#include "model_selection_test.h"
#include "order_selection_algorithm_test.h"
#include "incremental_order_test.h"
#include "golden_section_order_test.h"
#include "simulated_annealing_order_test.h"
#include "inputs_selection_algorithm_test.h"
#include "growing_inputs_test.h"
#include "pruning_inputs_test.h"
#include "genetic_algorithm_test.h"
#include "correlation_analysis_test.h"

#include "testing_analysis_test.h"

#endif

// OpenNN: Open Neural Networks Library.
// Copyright (C) 2005-2018 Artificial Intelligence Techniques, SL.
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
